<!--样式页面
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>卡密充值页面</title>
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
    <script src="/plugins/addons/card_kami/assets/layer.js"></script>
</head>
<body>
    <section class="admin-main">
        <div class="container-fluid">
            <div class="page-container">
                <div class="card">
                    <div class="card-body">
                        <div class="card-title row"> 
                            <div class="pl-4 pr-4">{$Title}</div>
                        </div>
                        <div class="tab-content mt-4">
                            <div class="table-body">
                                <form class="form" id="config">
                                    <div class="form-group row">
                                        <label>卡密</label>
                                        <div class="col-sm-4">
                                            <textarea rows="5" class="form-control" name="cami"></textarea>
                                        </div>
                                    </div>
                                    <div class="form-group row">
                                        <div class="col-sm-10">
                                            <button type="button" onclick="submits()" class="btn btn-primary w-md">充值</button>
                                        </div>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>

    <script>
        function submits() {
            // 获取用户ID
            var uid = {$Userinfo.user.id};
            // 序列化表单数据，并添加用户ID
            var data = $("#config").serialize();
            // 序列化表单数据，并添加用户ID
            //var data = $("#config").serialize() + '&uid=' + uid;
            var load = layer.load();
            $.ajax({
                url: "/addons?_plugin=card_kami&_controller=index&_action=recharge",
                type: 'post',
                data: data,
                dataType: 'json',
                success: function(data){
                    layer.close(load);
                    if(data.code != 200) {
                        layer.alert(data.msg, {icon: 2});
                    } else {
                        layer.alert(data.msg, {icon: 1}, function(){
                            location.reload();
                        });
                    }
                },
                error: function() {
                    layer.close(load);
                    layer.msg('请求失败');
                }
            });
        }
    </script>
</body>
</html>
-->


<!--影响好看，但速度慢
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>卡密充值</title>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" rel="stylesheet">
    <style>
        body {
            padding: 50px;
        }
    </style>
</head>
<body>
    <div class="container">
        <h2>卡密充值</h2>
        <form id="config">
            <div class="form-group">
                <label for="cami">卡密：</label>
                <input type="text" class="form-control" id="cami" name="cami" placeholder="输入卡密">
            </div>
            <button type="submit" class="btn btn-primary">提交</button>
        </form>
    </div>

    <script src="https://code.jquery.com/jquery-3.5.1.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/sweetalert2@10"></script>
    <script>
        $(document).ready(function() {
            $('#config').submit(function(event) {
                event.preventDefault(); // 阻止默认表单提交行为

                // 获取用户ID
                var uid = {$Userinfo.user.id};

                // 获取卡密
                var cami = $('#cami').val();

                // 发送数据到控制器
                var data = {
                    uid: uid,
                    cami: cami
                };

                $.ajax({
                    url: "/addons?_plugin=card_kami&_controller=index&_action=recharge",
                    type: 'post',
                    data: data,
                    dataType: 'json',
                    success: function(data) {
                        if (data.code != 200) {
                            Swal.fire({
                                icon: 'error',
                                title: '充值失败',
                                text: data.msg
                            });
                        } else {
                            Swal.fire({
                                icon: 'success',
                                title: '充值成功',
                                text: data.msg
                            }).then(function() {
                                location.reload();
                            });
                        }
                    },
                    error: function() {
                        Swal.fire({
                            icon: 'error',
                            title: '请求失败',
                            text: '请稍后重试'
                        });
                    }
                });
            });
        });
    </script>
</body>
</html>
-->


<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>卡密充值页面</title>
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
    <script src="/plugins/addons/card_kami/assets/layer.js"></script>
</head>
<body>
    <section class="admin-main">
        <div class="container-fluid">
            <div class="page-container">
                <div class="card">
                    <div class="card-body">
                        <div class="card-title row"> 
                            <div class="pl-4 pr-4">{$Title}</div>
                        </div>
                        <div class="tab-content mt-4">
                            <div class="table-body">
                                <form class="form" id="config">
                                    <div class="form-group row">
                                        <label>卡密</label>
                                        <div class="col-sm-4">
                                            <textarea rows="5" class="form-control" name="cami"></textarea>
                                        </div>
                                    </div>
                                    <div class="form-group row">
                                        <div class="col-sm-10">
                                            <button type="button" onclick="submits()" class="btn btn-primary w-md">充值</button>
                                        </div>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>

    <script>
        function submits() {
            // 获取用户ID
            var uid = {$Userinfo.user.id};
            // 序列化表单数据，并添加用户ID
            var data = $("#config").serialize();
            // 序列化表单数据，并添加用户ID
            //var data = $("#config").serialize() + '&uid=' + uid;
            var load = layer.load();
            $.ajax({
                url: "/addons?_plugin=card_kami&_controller=index&_action=recharge",
                type: 'post',
                data: data,
                dataType: 'json',
                success: function(data){
                    layer.close(load);
                    if(data.code != 200) {
                        layer.alert(data.msg, {icon: 2});
                    } else {
                        layer.alert(data.msg, {icon: 1}, function(){
                            location.reload();
                        });
                    }
                },
                error: function() {
                    layer.close(load);
                    layer.msg('请求失败');
                }
            });
        }
    </script>
</body>
</html>



















<!--
    <script>
        function submit() {
            // 获取用户ID
            var uid = {$Userinfo.user.id};
            // 序列化表单数据，并添加用户ID
            var data = $("#config").serialize();
            var load = layer.load();
            $.ajax({
                url: "/addons?_plugin=card_kami&_controller=index&_action=recharge",
                type: 'post',
                data: data,
                dataType: 'json',
                success: function(data){
                    layer.close(load);
                    if(data.code != 200) {
                        layer.alert(data.msg, {icon: 2});
                    } else {
                        layer.alert(data.msg, {icon: 1}, function(){
                            location.reload();
                        });
                    }
                },
                error: function() {
                    layer.close(load);
                    layer.msg('请求失败');
                }
            });
        }
    </script>
-->

<!--
<script>
  function submit() {
    // 获取用户ID
    var uid = {$Userinfo.user.id};
    // 序列化表单数据，并添加用户ID
    var data = $("#config").serialize();
    var load = layer.load();
    $.ajax({
        url: "/addons?_plugin=card_kami&_controller=index&_action=recharge"
        ,type: 'post'
        ,data: data
        ,dataType: 'json'
        ,success: function(data){
            layer.close(load);
            if(data.code != 200)
            {
                layer.alert(data.msg,{icon:2});
                return false;
            }else{
                layer.alert(data.msg,{icon:1},function(){
                    location.reload();
                });
            }
        }
        ,error: function(){
            layer.close(load);
            layer.msg('请求失败');
        }
    })
}
</script>
-->